#!/usr/bin/env python
# -*- coding: utf-8 -*-

# For GIMP 2.10 this plugin requires installation of additional plugins:
# apply-canvas.exe, bump-map.exe, cubism.exe, engrave.exe, felimage-noise.exe, kaleidoscope.exe, mosaic.exe, noise-generator.exe, noise-spread.exe, pixelize.exe, video.exe, voronoi.exe.

from gimpfu import *

def newline(x1, y1, x2, y2, x3, y3, x4, y4, x5, y5):
    return [x1,y1]*3+[x2,y2]*3+[x3,y3]*3+[x4,y4]*3+[x5,y5]*3
	
def python_fu_border_step_by_step(image, layer, empty, frame, c_type, gradient_type, efect, modepat, stroke, stroke_col, sel_col, del_path, merge):
	
	if efect==12:
		pdb.gimp_selection_none(image)
		
	black = (0,0,0)
	white = (255,255,255)
	
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
		
	parent = pdb.gimp_item_get_parent(layer)
	name = pdb.gimp_item_get_name(layer)
	position = pdb.gimp_image_get_item_position(image , layer)
	pdb.gimp_edit_copy(layer)
	copy = pdb.gimp_edit_paste(layer ,1)
	pdb.gimp_floating_sel_to_layer(copy)
	pdb.gimp_image_reorder_item(image ,copy ,parent ,position)
	pdb.gimp_item_set_visible(copy, 1)

	wi = pdb.gimp_image_width(image)
	hi = pdb.gimp_image_height(image)
	
	b = frame
	e = empty
	d = b + e
	
	new_width = wi + 2*d
	new_height = hi + 2*d
	
	wh = pdb.gimp_drawable_width(copy)
	hh = pdb.gimp_drawable_height(copy)
	centerx=wi/2
	centery=hi/2
	adw=wh/2
	adh=hh/2
	sw=centerx - adw
	sh=centery - adh		
	pdb.gimp_layer_set_offsets(copy, sw, sh)

	new_image = pdb.gimp_image_new(wi, hi, 0)
	display = pdb.gimp_display_new(new_image)
	##pdb.gimp_image_undo_group_start(new_image)
	active_layer = pdb.gimp_layer_new_from_drawable(copy, new_image)
	pdb.gimp_image_insert_layer(new_image, active_layer, None, 0)
	active_layer.name = layer.name
	
	sel=pdb.gimp_selection_is_empty(image)
	if sel==1 or efect==12:
		pdb.gimp_image_resize(new_image,new_width,new_height,d, d)
		pdb.gimp_layer_resize_to_image_size(active_layer)
		
	else:
		selection = pdb.gimp_selection_bounds(image)
		x1 = selection[1];
		y1 = selection[2];
		x2 = selection[3];
		y2 = selection[4];

		pdb.plug_in_autocrop(new_image, active_layer)
		pdb.gimp_image_select_item(new_image, 2, active_layer)
		x = x2-x1
		y = y2-y1
		wi = x+2*e
		hi = y+2*e
		wh = x+2*e
		hh = y+2*e
		new_width = wi +2*d
		new_height = hi +2*d
		pdb.gimp_image_resize(new_image,new_width,new_height,d+e, d+e)
		pdb.gimp_layer_resize_to_image_size(active_layer)

	mate_layer = pdb.gimp_layer_new_from_drawable(active_layer, new_image)
	pdb.gimp_image_insert_layer(new_image, mate_layer, None, 0)
	pdb.gimp_item_set_name(mate_layer, "Mate")
	pdb.gimp_edit_clear(mate_layer)
	pdb.gimp_image_lower_item_to_bottom(new_image, mate_layer)
	if not efect==19:	
		if c_type==0:	# slanted
			new_vectors_bl = pdb.gimp_vectors_new(new_image,"Border-L")
			pdb.gimp_image_insert_vectors(new_image, new_vectors_bl, None, -1)	
			pdb.gimp_vectors_stroke_new_from_points(new_vectors_bl, 0, 30, newline( d, d, d,hi+d,  e,hi+d+b, e,e, d,d), 1)
			pdb.gimp_item_set_visible(new_vectors_bl, False)
			
			new_vectors_bt = pdb.gimp_vectors_new(new_image,"Border-T")
			pdb.gimp_image_insert_vectors(new_image, new_vectors_bt, None, -1)	
			pdb.gimp_vectors_stroke_new_from_points(new_vectors_bt, 0, 30, newline(e,e,   d,d,  wi+d,d,  wi+d+b,e,  e,e), 1)
			pdb.gimp_item_set_visible(new_vectors_bt, False)

			new_vectors_br = pdb.gimp_vectors_new(new_image,"Border-R")
			pdb.gimp_image_insert_vectors(new_image, new_vectors_br, None, -1)	
			pdb.gimp_vectors_stroke_new_from_points(new_vectors_br, 0, 30, newline( wi+d,d,  wi+d+b,e,  wi+d+b,hi+d+b,  wi+d,hi+d,  wi+d,d), 1)
			pdb.gimp_item_set_visible(new_vectors_br, False)
			
			new_vectors_bb = pdb.gimp_vectors_new(new_image,"Border-B")
			pdb.gimp_image_insert_vectors(new_image, new_vectors_bb, None, -1)	
			pdb.gimp_vectors_stroke_new_from_points(new_vectors_bb, 0, 30, newline(wi+d+b,hi+d+b, wi+d,hi+d,  d,hi+d,  e,hi+d+b,   wi+d+b,hi+d+b), 1)
			pdb.gimp_item_set_visible(new_vectors_bb, False)
			
		else :	# rectangular top, rectangular side, rectangular mixed
			new_vectors_bl = pdb.gimp_vectors_new(new_image,"Border-L")
			pdb.gimp_image_insert_vectors(new_image, new_vectors_bl, None, -1)	
			pdb.gimp_vectors_stroke_new_from_points(new_vectors_bl, 0, 30, newline( d, e, d,hi+2*b+e,  e,hi+2*b+e, e,e, d,e), 1)
			pdb.gimp_item_set_visible(new_vectors_bl, False)
			
			new_vectors_bt = pdb.gimp_vectors_new(new_image,"Border-T")
			pdb.gimp_image_insert_vectors(new_image, new_vectors_bt, None, -1)	
			pdb.gimp_vectors_stroke_new_from_points(new_vectors_bt, 0, 30, newline(e,e,   e,d,  wi+2*b+e,d,  wi+2*b+e,e,  e,e), 1)
			pdb.gimp_item_set_visible(new_vectors_bt, False)

			new_vectors_br = pdb.gimp_vectors_new(new_image,"Border-R")
			pdb.gimp_image_insert_vectors(new_image, new_vectors_br, None, -1)	
			pdb.gimp_vectors_stroke_new_from_points(new_vectors_br, 0, 30, newline( wi+d,e,  wi+2*b+e,e,  wi+2*b+e,hi+2*b+e,  wi+d,hi+2*b+e,  wi+d,e), 1)
			pdb.gimp_item_set_visible(new_vectors_br, False)
			
			new_vectors_bb = pdb.gimp_vectors_new(new_image,"Border-B")
			pdb.gimp_image_insert_vectors(new_image, new_vectors_bb, None, -1)	
			pdb.gimp_vectors_stroke_new_from_points(new_vectors_bb, 0, 30, newline(wi+2*b+e,hi+2*b+e, wi+2*b+e,hi+d,  e,hi+d,  e,hi+2*b+e,   wi+2*b+e,hi+2*b+e), 1)
			pdb.gimp_item_set_visible(new_vectors_bb, False)
		pdb.gimp_image_remove_layer(image, copy)
	
	new_layer = pdb.gimp_layer_new(new_image,new_image.width,new_image.height,RGBA_IMAGE,"Border layer",100,0)
	pdb.gimp_image_insert_layer(new_image,new_layer,None,0)
	
#  CHANNEL-OP-ADD (0), CHANNEL-OP-SUBTRACT (1), CHANNEL-OP-REPLACE (2), CHANNEL-OP-INTERSECT (3)
#  GRADIENT-LINEAR (0) GRADIENT-SHAPEBURST-ANGULAR (6), GRADIENT-SHAPEBURST-SPHERICAL (7), GRADIENT-SHAPEBURST-DIMPLED (8)
	
	if gradient_type==0:
		gradtype=0
	if gradient_type==1:
		gradtype=6
	if gradient_type==2:
		gradtype=7
	if gradient_type==3:
		gradtype=8		

	if not efect==19:		
		pdb.gimp_image_select_item(new_image, 2, new_vectors_bl)
		pdb.gimp_edit_blend(new_layer, 0, 0, gradtype, 100, 0, 0, 0, 0, 1, 4, 0, d, d, e, d,)
		
		pdb.gimp_image_select_item(new_image, 2, new_vectors_br)	
		pdb.gimp_edit_blend(new_layer, 0, 0, gradtype, 100, 0, 0, 0, 0, 1, 4, 0, d+wi, d, wi+d+b, d,)
		
		pdb.gimp_image_select_item(new_image, 2, new_vectors_bt)	
		pdb.gimp_edit_blend(new_layer, 0, 0, gradtype, 100, 0, 0, 0, 0, 1, 4, 0, d, d, d, e,)

		pdb.gimp_image_select_item(new_image, 2, new_vectors_bb)
		pdb.gimp_edit_blend(new_layer, 0, 0, gradtype, 100, 0, 0, 0, 0, 1, 4, 0, d, d+hi, d, hi+d+b)
		
	if c_type==2:

		pdb.gimp_image_select_item(new_image, 2, new_vectors_bl)			
		pdb.gimp_edit_blend(new_layer, 0, 0, gradtype, 100, 0, 0, 0, 0, 1, 4, 0, d, d, e, d,)

		pdb.gimp_image_select_item(new_image, 2, new_vectors_br)
		pdb.gimp_edit_blend(new_layer, 0, 0, gradtype, 100, 0, 0, 0, 0, 1, 4, 0, d+wi, d, wi+d+b, d,)

	pdb.gimp_selection_none(new_image)
	
	if efect==0: # Do not use 
		border_layer = pdb.gimp_layer_new_from_drawable(new_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, border_layer, None, 0)
		pdb.gimp_item_set_name(border_layer, "Border layer-mode")
		lm = border_layer
		
	if efect==1:	# apply_canvas
		pdb.gimp_image_select_item(new_image, 2, new_layer)
		apply_canvas_layer = pdb.gimp_layer_new_from_drawable(new_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, apply_canvas_layer, None, 0)
		pdb.gimp_item_set_name(apply_canvas_layer, "Apply_canvas")		
		pdb.plug_in_apply_canvas(new_image, apply_canvas_layer, 1, 1, run_mode=RUN_INTERACTIVE)
		pdb.gimp_selection_none(new_image)		
		lm = apply_canvas_layer
		
	if efect==2:	# cubism
		pdb.gimp_image_select_item(new_image, 2, new_layer)
		cubism_layer = pdb.gimp_layer_new_from_drawable(new_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, cubism_layer, None, 0)
		pdb.gimp_item_set_name(cubism_layer, "Cubism")
		pdb.plug_in_cubism(new_image, cubism_layer, 1, 1, 1, run_mode=RUN_INTERACTIVE)
		pdb.gimp_selection_none(new_image)	
		lm = cubism_layer
		
	if efect==3:	# emboss
		pdb.gimp_image_select_item(new_image, 2, new_layer)
		emboss_layer = pdb.gimp_layer_new_from_drawable(new_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, emboss_layer, None, 0)
		pdb.gimp_item_set_name(emboss_layer, "Emboss")
		pdb.plug_in_emboss(new_image, emboss_layer, 1, 1, 1, 1, run_mode=RUN_INTERACTIVE)
		pdb.gimp_selection_none(new_image)	
		lm = emboss_layer
		
	if efect==4:	# engrawe
		pdb.gimp_image_select_item(new_image, 2, new_layer)
		engrawe_layer = pdb.gimp_layer_new_from_drawable(new_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, engrawe_layer, None, 0)
		pdb.gimp_item_set_name(engrawe_layer, "Engrawe")
		pdb.plug_in_engrave(new_image, engrawe_layer, 1, 1, run_mode=RUN_INTERACTIVE)
		pdb.gimp_selection_none(new_image)		
		lm = engrawe_layer
		
	if efect==5:	# FELIMAGE
		pdb.gimp_image_select_item(new_image, 2, new_layer)
		fimg_noise_layer = pdb.gimp_layer_new_from_drawable(new_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, fimg_noise_layer, None, 0)
		pdb.gimp_item_set_name(fimg_noise_layer, "Fimg_noise")		
		pdb.plug_in_fimg_noise(new_image, fimg_noise_layer,"", run_mode=RUN_INTERACTIVE)
		pdb.gimp_selection_none(new_image)			
		lm = fimg_noise_layer
		
	if efect==6:	# gimpressionist
		pdb.gimp_image_select_item(new_image, 2, new_layer)
		gimpressionist_layer = pdb.gimp_layer_new_from_drawable(new_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, gimpressionist_layer, None, 0)
		pdb.gimp_item_set_name(gimpressionist_layer, "Gimpressionist")
		pdb.plug_in_gimpressionist(new_image, gimpressionist_layer,"", run_mode=RUN_INTERACTIVE)
		pdb.gimp_selection_none(new_image)	
		lm = gimpressionist_layer
		
	if efect==7:	# kaleidoscope
		kaleidoscope_layer = pdb.gimp_layer_new_from_drawable(active_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, kaleidoscope_layer, None, 0)
		pdb.gimp_item_set_name(kaleidoscope_layer, "Kaleidoscope")
		pdb.gimp_drawable_transform_scale(kaleidoscope_layer, -2*d, -2*d, new_image.width+2*d,new_image.height+2*d, 0,1,0,1,1)
		pdb.plug_in_kaleidoscope(new_image, kaleidoscope_layer, 1, 1, 1, 1, run_mode=RUN_INTERACTIVE)
		
		new_vectors_out = pdb.gimp_vectors_new(new_image,"Box - out")
		pdb.gimp_image_insert_vectors(new_image, new_vectors_out, None, -1)	
		pdb.gimp_vectors_stroke_new_from_points(new_vectors_out, 0, 30,newline(e,e,  wi+b+d,e,  wi+b+d,hi+b+d,  e,hi+b+d,  e,e), 1)
		pdb.gimp_item_set_visible(new_vectors_out, False)
		pdb.gimp_image_select_item(new_image, 0, new_vectors_out)
		pdb.gimp_selection_invert(new_image)
		pdb.gimp_edit_clear(kaleidoscope_layer)
		# CHANNEL-OP-ADD (0), CHANNEL-OP-SUBTRACT (1), CHANNEL-OP-REPLACE (2), CHANNEL-OP-INTERSECT (3)
		pdb.gimp_selection_none(new_image)
		new_vectors_in = pdb.gimp_vectors_new(new_image,"Box - in")
		pdb.gimp_image_insert_vectors(new_image, new_vectors_in, None, -1)	
		pdb.gimp_vectors_stroke_new_from_points(new_vectors_in, 0, 30, newline( d,d,  wi+d,d,  wi+d,hi+d,  d,hi+d,  d,d), 1)
		pdb.gimp_item_set_visible(new_vectors_in, False)
		pdb.gimp_image_select_item(new_image, 0, new_vectors_in)
		pdb.gimp_edit_clear(kaleidoscope_layer)
		
		pdb.gimp_layer_resize_to_image_size(kaleidoscope_layer)
		pdb.gimp_selection_none(new_image)
		lm = kaleidoscope_layer	
		
	if efect==8:	# mosaic
		pdb.gimp_image_select_item(new_image, 2, new_layer)
		mosaic_layer = pdb.gimp_layer_new_from_drawable(new_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, mosaic_layer, None, 0)
		pdb.gimp_item_set_name(mosaic_layer, "Mosaic")		
		pdb.plug_in_mosaic(new_image, mosaic_layer, 10, 1, 4, 1, 0, 0, 0, 1, 0, 0, 0, 1,run_mode=RUN_INTERACTIVE)
		pdb.gimp_selection_none(new_image)
		lm = mosaic_layer
		
	if efect==9:	# NEWSPRINT
		pdb.gimp_image_select_item(new_image, 2, new_layer)
		newsprint_layer = pdb.gimp_layer_new_from_drawable(new_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, newsprint_layer, None, 0)
		pdb.gimp_item_set_name(newsprint_layer, "Newsprint")			
		pdb.plug_in_newsprint(new_image, newsprint_layer, 1, 3, 50, 180, 0, 1.0, 0, 90.0, 0, 5.0, 0, 10,run_mode=RUN_INTERACTIVE)
		pdb.gimp_selection_none(new_image)				
		lm = newsprint_layer
		
	if efect==10:	# NOISE GENERATOR
		pdb.gimp_image_select_item(new_image, 2, new_layer)
		noise_generator_layer = pdb.gimp_layer_new_from_drawable(new_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, noise_generator_layer, None, 0)
		pdb.gimp_item_set_name(noise_generator_layer, "Noise_generator")		
		pdb.plug_in_noise_generator(new_image, noise_generator_layer, 1, 1, 1, 1, 1, 1,run_mode=RUN_INTERACTIVE)
		pdb.gimp_selection_none(new_image)
		lm = noise_generator_layer
		
	if efect==11:	# PATTERN_FILL
		pattern_layer_tb = pdb.gimp_layer_new(new_image,new_image.width,new_image.height,RGBA_IMAGE,"Texture layer",100,0)
		pdb.gimp_image_insert_layer(new_image,pattern_layer_tb,None,0)

		pdb.gimp_image_rotate(new_image, 0)
		pdb.gimp_image_select_item(new_image, 2, new_vectors_bt)
		pdb.gimp_image_select_item(new_image, 0, new_vectors_bb)
		pdb.gimp_context_get_pattern()
		pdb.gimp_drawable_fill(pattern_layer_tb, 4)
		pdb.gimp_selection_invert(new_image)
		pdb.gimp_edit_clear(pattern_layer_tb)
		
		pdb.gimp_image_rotate(new_image, 2)
		pattern_layer_lr = pdb.gimp_layer_new(new_image,new_image.width,new_image.height,RGBA_IMAGE,"Texture layer",100,0)
		pdb.gimp_image_insert_layer(new_image,pattern_layer_lr,None,0)
		pdb.gimp_selection_invert(new_image)
		pdb.gimp_image_select_item(new_image, 2, new_vectors_br)
		pdb.gimp_image_select_item(new_image, 0, new_vectors_bl)
		
		pdb.gimp_context_get_pattern()
		pdb.gimp_drawable_fill(pattern_layer_lr, 4)
		pdb.gimp_selection_invert(new_image)
		pdb.gimp_edit_clear(pattern_layer_lr)
		pattern_layer = pdb.gimp_image_merge_down(new_image,pattern_layer_lr,EXPAND_AS_NECESSARY)
		pdb.gimp_image_select_item(new_image, 2, pattern_layer)
				
		#pdb.gimp_drawable_desaturate(pattern_layer, 0)
		pdb.plug_in_bump_map(new_image, pattern_layer, pattern_layer, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, run_mode=RUN_INTERACTIVE)
		pdb.gimp_selection_none(new_image)
		lm = pattern_layer
		
	if efect==12:	#  perspective	
		pdb.gimp_selection_none(image)	
		perspective_layer = pdb.gimp_layer_new_from_drawable(active_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, perspective_layer, None, 0)
		pdb.gimp_item_set_name(perspective_layer, "Perspective")
		pdb.gimp_drawable_transform_scale(perspective_layer, -2*d, -2*d, new_image.width+2*d,new_image.height+2*d, 0,1,0,1,1)
		pdb.gimp_image_select_item(new_image, 2, perspective_layer)

		nw = wi + 2*d
		nh = hi + 2*d
		
		lb_layer = pdb.gimp_layer_copy(perspective_layer,TRUE)
		pdb.gimp_image_insert_layer(new_image,lb_layer,None,0)
		pdb.gimp_item_transform_perspective(lb_layer,e,e, d,d, e,nh-e, d,nh-d)
		pdb.gimp_edit_paste(lb_layer ,0)

		rb_layer = pdb.gimp_layer_copy(perspective_layer,TRUE)
		pdb.gimp_image_insert_layer(new_image,rb_layer,None,0)
		pdb.gimp_item_transform_perspective(rb_layer,wi+d,d, wi+d+b,e, wi+d,hi+d, wi+d+b,hi+d+b,)
		merged_layer = pdb.gimp_image_merge_down(new_image,rb_layer,EXPAND_AS_NECESSARY)
		
		tb_layer = pdb.gimp_layer_copy(perspective_layer,TRUE)
		pdb.gimp_image_insert_layer(new_image,tb_layer,None,0)
		pdb.gimp_item_transform_perspective(tb_layer,e,e,wi+d+b,e, d,d,  wi+d,d)
		merged_layer = pdb.gimp_image_merge_down(new_image,tb_layer,EXPAND_AS_NECESSARY)

		bb_layer = pdb.gimp_layer_copy(perspective_layer,TRUE)
		pdb.gimp_image_insert_layer(new_image,bb_layer,None,0)
		pdb.gimp_item_transform_perspective(bb_layer, d,hi+d, wi+d,hi+d,  e,hi+d+b,   wi+d+b,hi+d+b,)
		merged_layer = pdb.gimp_image_merge_down(new_image,bb_layer,EXPAND_AS_NECESSARY)
		
		pdb.gimp_edit_clear(perspective_layer)
		pdb.gimp_image_merge_down(new_image,perspective_layer,EXPAND_AS_NECESSARY)
		pdb.gimp_selection_none(new_image)
		lm = merged_layer
		
	if efect==13:	# pixelize
		pdb.gimp_image_select_item(new_image, 2, new_layer)
		pixelize_layer = pdb.gimp_layer_new_from_drawable(new_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, pixelize_layer, None, 0)
		pdb.gimp_item_set_name(pixelize_layer, "Pixelize")			
		pdb.plug_in_pixelize2(new_image, pixelize_layer, 1, 1, run_mode=RUN_INTERACTIVE)
		pdb.gimp_selection_none(new_image)
		lm = pixelize_layer

	if efect==14:	#  REFLEXION BORDER
		pdb.gimp_selection_none(new_image)
		per_layer = pdb.gimp_layer_new_from_drawable(active_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, per_layer, None, 0)
		pdb.gimp_item_set_name(per_layer, "Reflexion")
		pdb.gimp_drawable_transform_scale(per_layer, -2*d, -2*d, new_image.width+2*d,new_image.height+2*d, 0,1,0,1,1)
		pdb.gimp_image_select_item(new_image, 2, new_layer)
		pdb.gimp_selection_invert(new_image)
		pdb.gimp_edit_clear(per_layer)
	
		j = int(frame)/2
		
		for i in range(1,j):
			pdb.gimp_selection_none(new_image)
			per_layer = pdb.gimp_layer_new_from_drawable(active_layer, new_image)
			pdb.gimp_image_insert_layer(new_image, per_layer, None, 0)
			pdb.gimp_item_set_name(per_layer, "Reflexion-b")
			pdb.gimp_drawable_transform_scale(per_layer, -2*d/i, -2*d/i, new_image.width+2*d/i,new_image.height+2*d/i, 0,1,0,1,1)
			pdb.gimp_image_select_item(new_image, 2, new_layer)
			pdb.gimp_selection_invert(new_image)
			pdb.gimp_edit_clear(per_layer)
			per_layer = pdb.gimp_image_merge_down(new_image,per_layer,EXPAND_AS_NECESSARY)
			
		pdb.gimp_selection_none(new_image)	
		pdb.gimp_layer_resize_to_image_size(per_layer)
		lm = per_layer
		
	if efect==15:	# ripple
		pdb.gimp_image_select_item(new_image, 2, new_layer)
		ripple_layer = pdb.gimp_layer_new_from_drawable(new_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, ripple_layer, None, 0)
		pdb.gimp_item_set_name(ripple_layer, "Ripple")		
		pdb.plug_in_ripple(new_image, ripple_layer, 1, 1, 1, 1, 1, 1, 1, run_mode=RUN_INTERACTIVE)
		pdb.gimp_selection_none(new_image)	
		lm = ripple_layer
		
	if efect==16:	# spread
		pdb.gimp_image_select_item(new_image, 2, new_layer)
		spread_layer = pdb.gimp_layer_new_from_drawable(new_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, spread_layer, None, 0)
		pdb.gimp_item_set_name(spread_layer, "Spread")		
		pdb.plug_in_spread(new_image, spread_layer, 1, 1, run_mode=RUN_INTERACTIVE)
		pdb.gimp_selection_none(new_image)		
		lm = spread_layer
		
	if efect==17:	# video
		pdb.gimp_image_select_item(new_image, 2, new_layer)
		video_layer = pdb.gimp_layer_new_from_drawable(new_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, video_layer, None, 0)
		pdb.gimp_item_set_name(video_layer, "Video")		
		pdb.plug_in_video(new_image, video_layer, 1, 1, 1, run_mode=RUN_INTERACTIVE)
		pdb.gimp_selection_none(new_image)
		lm = video_layer
		
	if efect==18:	# VORONOI
		pdb.gimp_image_select_item(new_image, 2, new_layer)
		voronoi_layer = pdb.gimp_layer_new_from_drawable(new_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, voronoi_layer, None, 0)
		pdb.gimp_item_set_name(voronoi_layer, "Voronoi")		
		pdb.plug_in_voronoi(new_image, voronoi_layer, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, run_mode=RUN_INTERACTIVE)
		pdb.gimp_selection_none(new_image)		
		lm = voronoi_layer
		
	if efect==19:	# IRREGULARLY SHAPED FRAME
		pdb.gimp_image_remove_layer(image, copy)
		pdb.gimp_image_select_item(new_image, 0, active_layer)
		pdb.gimp_selection_grow(new_image, empty+frame/2)
		
		pdb.plug_in_sel2path(new_image, active_layer,run_mode=RUN_NONINTERACTIVE)
		active_vectors = pdb.gimp_image_get_active_vectors(new_image)
		
		pdb.gimp_selection_border(new_image, frame/2)
		pdb.gimp_edit_blend(new_layer, 0, 0, gradtype, 100, 0, 0, 0, 0, 1, 4, 0, new_image.width/2,new_image.height/2,new_image.width/2,b+new_image.height/2)
		sel_layer = pdb.gimp_layer_new_from_drawable(new_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, sel_layer, None, 0)
		pdb.gimp_item_set_name(sel_layer, "By selection")
		neon_layer = pdb.gimp_layer_new_from_drawable(sel_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, neon_layer, None, 0)
		pdb.gimp_item_set_name(neon_layer, "Neon")
		pdb.plug_in_neon(new_image, neon_layer, 1, 1, run_mode=RUN_INTERACTIVE)
		pdb.gimp_edit_clear(sel_layer)
		pdb.gimp_image_select_item(new_image, 2, active_vectors)
		
		if sel_col==0:		# Awerage color
			r, _, _, _, _, _ = pdb.gimp_histogram(active_layer,HISTOGRAM_RED,0,255)
			g, _, _, _, _, _ = pdb.gimp_histogram(active_layer,HISTOGRAM_GREEN,0,255)
			b, _, _, _, _, _ = pdb.gimp_histogram(active_layer,HISTOGRAM_BLUE,0,255)
			pdb.gimp_context_set_foreground((int(r),int(g),int(b)))
			pdb.gimp_edit_fill(sel_layer,0)
			
		if sel_col==1:
			pdb.gimp_context_get_foreground()
			pdb.gimp_edit_fill(sel_layer,0)
			
		if sel_col==2:
			pdb.gimp_edit_fill(sel_layer,1)
			
		if sel_col==3:		
			pdb.gimp_context_set_foreground(black)
			pdb.gimp_edit_fill(sel_layer,0)
			
		if sel_col==4:		
			pdb.gimp_context_set_foreground(white)			
			pdb.gimp_edit_fill(sel_layer,0)

		if sel_col==5:		
			pdb.gimp_context_set_pattern(pdb.gimp_context_get_pattern())		
			pdb.gimp_edit_fill(sel_layer,4)
			

		pdb.gimp_image_lower_item_to_bottom(new_image, sel_layer)
		pdb.gimp_image_raise_item(new_image, sel_layer)
		pdb.gimp_selection_none(new_image)
		lm = neon_layer
	
	
	if modepat==0: # NORMAL-LEGACY (0)
		pdb.gimp_layer_set_mode(lm, 0)
	if modepat==1:  # DISSOLVE (1)
		pdb.gimp_layer_set_mode(lm, 1)
	if modepat==2: # BEHIND-LEGACY (2)
		pdb.gimp_layer_set_mode(lm, 2)
	if modepat==3:	# MULTIPLY-LEGACY (3)
		pdb.gimp_layer_set_mode(lm, 3)
	if modepat==4:	# SCREEN-LEGACY (4)
		pdb.gimp_layer_set_mode(lm, 4)
	if modepat==5:	# OVERLAY-LEGACY (5)
		pdb.gimp_layer_set_mode(lm, 5)
	if modepat==6:	 # DIFFERENCE-LEGACY (6)
		pdb.gimp_layer_set_mode(lm, 6)
	if modepat==7: # ADDITION-LEGACY (7)
		pdb.gimp_layer_set_mode(lm, 7)
	if modepat==8:	# SUBTRACT-LEGACY (8)
		pdb.gimp_layer_set_mode(lm, 8)
	if modepat==9:	# DARKEN-ONLY-LEGACY (9)
		pdb.gimp_layer_set_mode(lm, 9)
	if modepat==10:	# LIGHTEN-ONLY-LEGACY (10)
		pdb.gimp_layer_set_mode(lm, 10)
	if modepat==11:	 # HSV-HUE-LEGACY (11)
		pdb.gimp_layer_set_mode(lm, 11)
	if modepat==12:	 # HSV-SATURATION-LEGACY (12)
		pdb.gimp_layer_set_mode(lm, 12)
	if modepat==13:	# HSL-COLOR-LEGACY (13)
		pdb.gimp_layer_set_mode(lm, 13)
	if modepat==14:	# HSV-VALUE-LEGACY (14)
		pdb.gimp_layer_set_mode(lm, 14)
	if modepat==15:	# DIVIDE-LEGACY (15)
		pdb.gimp_layer_set_mode(lm, 15)
	if modepat==16:	 # DODGE-LEGACY (16)
		pdb.gimp_layer_set_mode(lm, 16)
	if modepat==17:	# BURN-LEGACY  (17)
		pdb.gimp_layer_set_mode(lm, 17)
	if modepat==18:	# HARDLIGHT-LEGACY (18)
		pdb.gimp_layer_set_mode(lm, 18)
	if modepat==19:	 # SOFTLIGHT-LEGACY (19)
		pdb.gimp_layer_set_mode(lm, 19)
	if modepat==20:	 # GRAIN-EXTRACT-LEGACY (20)
		pdb.gimp_layer_set_mode(lm, 20)
	if modepat==21:	 # GRAIN-MERGE-LEGACY (21)
		pdb.gimp_layer_set_mode(lm, 21)
	if modepat==22:	# COLOR-ERASE-LEGACY (22)
		pdb.gimp_layer_set_mode(lm, 22)
	if modepat==23:	# LCH-HUE (24)
		pdb.gimp_layer_set_mode(lm, 24)
	if modepat==24:	# LCH-CHROMA (25)
		pdb.gimp_layer_set_mode(lm, 25)
	if modepat==25:	# LCH-COLOR (26)
		pdb.gimp_layer_set_mode(lm, 26)
	if modepat==26:	# LCH-LIGHTNESS (27)
		pdb.gimp_layer_set_mode(lm, 27)
	if modepat==27:	# VIVID-LIGHT (48)
		pdb.gimp_layer_set_mode(lm, 48)
	if modepat==28:	# PIN-LIGHT (49)
		pdb.gimp_layer_set_mode(lm, 49)
	if modepat==29:	# LINEAR-LIGHT (50)
		pdb.gimp_layer_set_mode(lm, 50)
	if modepat==30:	# HARD-MIX (51)
		pdb.gimp_layer_set_mode(lm, 51)
	if modepat==31:	# EXCLUSION (52)
		pdb.gimp_layer_set_mode(lm, 52)
	if modepat==32:	# LINEAR-BURN (53)
		pdb.gimp_layer_set_mode(lm, 53)
	if modepat==33:	# LUMA-DARKEN-ONLY (54)
		pdb.gimp_layer_set_mode(lm, 54)
	if modepat==34:	# LUMA-LIGHTEN-ONLY (55)
		pdb.gimp_layer_set_mode(lm, 55)
	if modepat==35:	# LUMINANCE (56)
		pdb.gimp_layer_set_mode(lm, 56)
	if modepat==36:	# SPLIT (60)
		pdb.gimp_layer_set_mode(lm, 60)
	if modepat==37:	# PASS-THROUGH (61)
		pdb.gimp_layer_set_mode(lm, 61)
	if modepat==38:	# REPLACE (62)
		pdb.gimp_layer_set_mode(lm, 62)
	if modepat==39:	# ANTI-ERASE (63)
		pdb.gimp_layer_set_mode(lm, 63)	
			
	if stroke==1:
		if stroke_col==1:	
			pdb.gimp_context_swap_colors()
		if stroke_col==2:	
			pdb.gimp_context_set_foreground(black)
		if stroke_col==3:	
			pdb.gimp_context_set_foreground(white)
			
		new_vectors_in = pdb.gimp_vectors_new(new_image,"Box - in")
		pdb.gimp_image_insert_vectors(new_image, new_vectors_in, None, -1)	
		pdb.gimp_vectors_stroke_new_from_points(new_vectors_in, 0, 30, newline( d,d,  wi+d,d,  wi+d,hi+d,  d,hi+d,  d,d), 1)
		pdb.gimp_item_set_visible(new_vectors_in, False)
		pdb.gimp_selection_none(new_image)
		stroke_b = pdb.gimp_layer_new(new_image,new_image.width,new_image.height,RGBA_IMAGE,"box stroke",100,0)
		pdb.gimp_image_insert_layer(new_image,stroke_b,None,0)
		pdb.gimp_edit_stroke_vectors(stroke_b ,new_vectors_in)
	
	if stroke==2:
		if stroke_col==1:	
			pdb.gimp_context_swap_colors()
		if stroke_col==2:	
			pdb.gimp_context_set_foreground(black)
		if stroke_col==3:	
			pdb.gimp_context_set_foreground(white)
			
		new_vectors_out = pdb.gimp_vectors_new(new_image,"Box - out")
		pdb.gimp_image_insert_vectors(new_image, new_vectors_out, None, -1)	
		pdb.gimp_vectors_stroke_new_from_points(new_vectors_out, 0, 30, newline(e,e,  wi+b+d,e,  wi+b+d,hi+b+d,  e,hi+b+d,  e,e), 1)
		pdb.gimp_item_set_visible(new_vectors_out, False)
		pdb.gimp_selection_none(new_image)
		stroke_b = pdb.gimp_layer_new(new_image,new_image.width,new_image.height,RGBA_IMAGE,"box stroke",100,0)
		pdb.gimp_image_insert_layer(new_image,stroke_b,None,0)
		pdb.gimp_edit_stroke_vectors(stroke_b ,new_vectors_out)
		
	if stroke==3:
		if stroke_col==1:	
			pdb.gimp_context_swap_colors()
		if stroke_col==2:	
			pdb.gimp_context_set_foreground(black)
		if stroke_col==3:	
			pdb.gimp_context_set_foreground(white)
			
		new_vectors_in = pdb.gimp_vectors_new(new_image,"Box - in")
		pdb.gimp_image_insert_vectors(new_image, new_vectors_in, None, -1)	
		pdb.gimp_vectors_stroke_new_from_points(new_vectors_in, 0, 30, newline( d,d,  wi+d,d,  wi+d,hi+d,  d,hi+d,  d,d), 1)
		pdb.gimp_item_set_visible(new_vectors_in, False)		
 		new_vectors_out = pdb.gimp_vectors_new(new_image,"Box - out")
		pdb.gimp_image_insert_vectors(new_image, new_vectors_out, None, -1)	
		pdb.gimp_vectors_stroke_new_from_points(new_vectors_out, 0, 30,newline(e,e,  wi+b+d,e,  wi+b+d,hi+b+d,  e,hi+b+d,  e,e), 1)
		pdb.gimp_item_set_visible(new_vectors_out, False)
		pdb.gimp_selection_none(new_image)
		stroke_b = pdb.gimp_layer_new(new_image,new_image.width,new_image.height,RGBA_IMAGE,"box stroke",100,0)
		pdb.gimp_image_insert_layer(new_image,stroke_b,None,0)
		pdb.gimp_edit_stroke_vectors(stroke_b ,new_vectors_in)		
		pdb.gimp_edit_stroke_vectors(stroke_b ,new_vectors_out)
	
	if sel==0 and not efect==19: 

		new_vectors_e = pdb.gimp_vectors_new(new_image,"BG")
		pdb.gimp_image_insert_vectors(new_image, new_vectors_e, None, -1)	
		pdb.gimp_vectors_stroke_new_from_points(new_vectors_e, 0, 30, newline( d,d,  wi+d,d,  wi+d,hi+d,  d,hi+d,  d,d), 1)
		pdb.gimp_item_set_visible(new_vectors_e, False)

		e_layer = pdb.gimp_layer_new_from_drawable(active_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, e_layer, None, 0)
		pdb.gimp_image_select_item(new_image, 2, new_vectors_e)
		pdb.gimp_item_set_name(e_layer, "Border sel color")
		pdb.gimp_edit_clear(e_layer)

		if sel_col==0:		# Awerage color
			r, _, _, _, _, _ = pdb.gimp_histogram(active_layer,HISTOGRAM_RED,0,255)
			g, _, _, _, _, _ = pdb.gimp_histogram(active_layer,HISTOGRAM_GREEN,0,255)
			b, _, _, _, _, _ = pdb.gimp_histogram(active_layer,HISTOGRAM_BLUE,0,255)
			pdb.gimp_context_set_foreground((int(r),int(g),int(b)))
			pdb.gimp_edit_fill(e_layer,0)
			
		if sel_col==1:
			pdb.gimp_context_get_foreground()
			pdb.gimp_edit_fill(e_layer,0)
			
		if sel_col==2:
			pdb.gimp_edit_fill(e_layer,1)
			
		if sel_col==3:		
			pdb.gimp_context_set_foreground(black)
			pdb.gimp_edit_fill(e_layer,0)
			
		if sel_col==4:		
			pdb.gimp_context_set_foreground(white)			
			pdb.gimp_edit_fill(e_layer,0)

		if sel_col==5:		
			pdb.gimp_context_set_pattern(pdb.gimp_context_get_pattern())		
			pdb.gimp_edit_fill(e_layer,4)			

		pdb.gimp_image_lower_item_to_bottom(new_image, e_layer)
		pdb.gimp_image_raise_item(new_image, e_layer)
		#pdb.gimp_selection_none(new_image)
		
	if del_path==1:
		for v in new_image.vectors:
			pdb.gimp_image_remove_vectors(new_image, v)

	if merge==1:
		pdb.gimp_image_merge_visible_layers(new_image, 1)
	##pdb.gimp_image_undo_group_end(new_image)
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
	return

register (
	"python-fu-border-step-by-step",
	"Create border \"Step by step\" for GIMP 2.8-2.10 with use:\n - gradient FG-to-BG-(RGB) that is: BG "u'\u21A4'" FG "u'\u21A6'" BG,\n - repeat plugin for new image (Ctr+F),\n - for proper operation in GIMP 2.10 it is necessary to install additional plugins (which they exist in GIMP 2.8),\n - if Merge Layers = no, You can select the border layer mode experimentally. ",
	"Create border step by step for GIMP 2.10\nVersion 0.8",
	"MareroQ",
	"GPL",
	"2019",
	"Create border \"Step by step\"...",
	"*",
	[
	(PF_IMAGE, "image", "", None),
	(PF_DRAWABLE, "drawable", "", None),
	(PF_SPINNER, "empty", "Empty margin (size in px):\n(= border selection) ", 0, (0, 1000, 1)),
	(PF_SPINNER, "frame", "Frame thickness (size in px): ", 10, (3, 1000, 1)),
	(PF_OPTION, "c_type", "Corner type:", 0, [" SLANTED "," RECTANGULAR T-B "," RECTANGULAR R-L "]),
	(PF_OPTION, "gradient_type", "Gradient type:", 0, [" LINEAR "," SHAPEBURST-ANGULAR "," SHAPEBURST-SPHERICAL "," SHAPEBURST-DIMPLED "]),
	(PF_OPTION,  "efect", "Additional effect:\n (INTERACTIVE) ", 0, ["Do not use "," APPLY CANVAS "," CUBISM "," EMBOSS "," ENGRAVE ",
	" FELIMAGE (only 32bit) "," GIMPRESSIONIST "," KALEIDOSCOPE "," MOSAIC "," NEWSPRINT "," NOISE GENERATOR "," PATTERN FILL \n(the currently ACTIVE pattern)",
	" PERSPECTIVE BORDER\n (without selection) "," PIXELIZE "," REFLEXION BORDER "," RIPPLE "," SPREAD "," VIDEO "," VORONOI "," IRREGULARLY SHAPED FRAME\n (from selection) "]),
	#(PF_PATTERN, "pattern", " - Pattern fill", None),
	(PF_OPTION, "modepat", "Layer-mode for border effect:\n (TOP LAYER)", 0, 
	[" NORMAL-LEGACY (0) "," DISSOLVE (1) "," BEHIND-LEGACY (2) "," MULTIPLY-LEGACY (3) "," SCREEN-LEGACY (4) "," OVERLAY-LEGACY (5) ",
	" DIFFERENCE-LEGACY (6) "," ADDITION-LEGACY (7) "," SUBTRACT-LEGACY (8) "," DARKEN-ONLY-LEGACY (9) "," LIGHTEN-ONLY-LEGACY (10) ",
	" HSV-HUE-LEGACY (11) "," HSV-SATURATION-LEGACY (12) "," HSL-COLOR-LEGACY (13) "," HSV-VALUE-LEGACY (14) "," DIVIDE-LEGACY (15) ",
	" DODGE-LEGACY (16) "," BURN-LEGACY  (17) "," HARDLIGHT-LEGACY (18) "," SOFTLIGHT-LEGACY (19) "," GRAIN-EXTRACT-LEGACY (20) ",
	" GRAIN-MERGE-LEGACY (21) "," COLOR-ERASE-LEGACY (22) ",
	" === ONLY GIMP 2.10: ===\nLCH-HUE (24) "," LCH-CHROMA (25) "," LCH-COLOR (26) "," LCH-LIGHTNESS (27) "," VIVID-LIGHT (48)"," PIN-LIGHT (49) "," LINEAR-LIGHT (50) ",
	" HARD-MIX (51) "," EXCLUSION (52) "," LINEAR-BURN (53) "," LUMA-DARKEN-ONLY (54) "," LUMA-LIGHTEN-ONLY (55) "," LUMINANCE (56) ",
	" SPLIT (60) "," PASS-THROUGH (61) "," REPLACE (62) "," ANTI-ERASE (63) "]),
	(PF_OPTION, "stroke", "Stroke box with ACTIVE brush?:", 0, [" Don't stroke ", " Inside frame box  "," Outside frame box "," Both bordering "]),
	(PF_OPTION, "stroke_col", "Stroke color brush:", 0, [ " Foreground Color "," Background Color "," Black "," White "]),
	(PF_OPTION, "sel_col", "Border selection fill:", 0, [ " Avarage Color "," Foreground Color "," Background Color "," Black "," White "," Active Pattern "]),
	(PF_TOGGLE,  "del_path", "Delete paths: ", 0 ),
	(PF_TOGGLE,  "merge", "Merge layers: ", 0 ),		
    ],
    [],
    python_fu_border_step_by_step, menu = "<Image>/Filters/Decor"
    )

main()
